=== debian/changelog ===
libfido2 (1.6.0-2) unstable; urgency=medium

  * No-op change from 1.6.0-1 to fix dgit history.

 -- Colin Watson <cjwatson@debian.org>  Sat, 16 Jan 2021 22:46:13 +0000

libfido2 (1.6.0-1) unstable; urgency=medium

  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Sat, 16 Jan 2021 22:42:52 +0000
